import javafx.scene.canvas.Canvas;
import javafx.scene.paint.Color;

/**
 * キャンバス
 * <pre>
 * キャンバスを継承したオブジェクト。
 * Canvasを継承し、ほぼスーパークラスの機能を利用していますが、
 * 共通的な部分の設定を行います。
 * 独自の設定は、当クラスを継承してください。
 * </pre>
 */
public class KCanvas extends Canvas {

	/** パネル */
	protected KPanel panel = null;

	/**
	 * コンストラクタ
	 * @param panel パネル
	 * @param x 表示位置。X座標。
	 * @param y 表示位置。Y座標。
	 */
	public KCanvas(KPanel panel, double width, double height){

		super(width, height);

		// パネルの保持
		this.panel = panel;

	} // end KCanvas

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * </pre>
	 */
	public void run(){

	}

	/**
	 * パネル取得
	 */
	public KPanel getKPanel(){
		return panel;
	}

}
