import javafx.scene.image.Image;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

/**
 * タイトル
 */
public class KCanvasTitleFX extends KCanvas implements KConstant {

	private static Image	imageTitleFX		= null;

	/** 時間 */
	private		int			time				= 0;

	/** 前景色 */
	private		Color		colorForeground		= Color.YELLOW;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		imageTitleFX = KImage.getImage("image\\imageTitleFX.gif");

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KCanvasTitleFX(KPanel panel){

		super(panel, WIDTH, HEIGHT);

	}

	/**
	 * 初期化
	 * <pre>
	 * 時間を戻します。
	 * </pre>
	 */
	public void init(){

		time = 0;

	} // end init

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// 時間＋１
		time++;

		// 時間計算
		time = (time > 1800)?192: time;

		// GraphicsContextを取得
		GraphicsContext gc = super.getGraphicsContext2D();

		// クリア
		gc.clearRect(0, 0, WIDTH, HEIGHT);

		// 3.2秒
		if(time < 192){

			// 何もしない

		// 3.4秒
		}else if(time < 204){

			// 位置
			double x = 384 + (204 - time) * 20;

			// イメージを描画
			gc.drawImage(imageTitleFX, x, 240);

		// 3.6秒
		}else if(time < 216){

			// イメージを描画
			gc.drawImage(imageTitleFX, 384, 240);

			// 位置
			double x = 384 + (216 - time) * 20;

			// イメージを描画
			gc.drawImage(imageTitleFX, x, 240);

		// 3.8秒
		}else if(time < 228){

			// イメージを描画
			gc.drawImage(imageTitleFX, 384, 240);

			// 位置
			double x = 384 + (228 - time) * 20;

			// イメージを描画
			gc.drawImage(imageTitleFX, x, 240);

		// 3.8秒
		}else if(time == 228){

			// 効果音をスタート
			((KCtrlSKK)panel.getKCtrl()).startWaveFX();

		// 3.8秒
		}else{

			// イメージを描画
			gc.drawImage(imageTitleFX, 384, 240);

		} // end if

	} // end paint
}
