import javafx.scene.image.Image;
import java.util.*;

/**
 * 地上物 32ドット 破壊可能
 * G31 CA-6508 6508 Brain Chip
 * G32 CA-L01  L-LED
 * G33 CA-CM1  Coile-Man
 * G34 CA-CC1  CemiCon-BR
 * G35 CA-CC2  SemiCon-BL
 * G36 CA-T3S  Teiko-3s
 */
public class KSpriteG31 extends KSpriteG00 implements KConstant {

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageG31 = null;
		Image imageG32_0 = null;
		Image imageG32_1 = null;
		Image imageG32_2 = null;
		Image imageG32_3 = null;
		Image imageG33 = null;
		Image imageG34 = null;
		Image imageG35 = null;
		Image imageG36 = null;

		imageG31 = KImage.getImage("image\\imageG31.gif");
		imageG32_0 = KImage.getImage("image\\imageG32_0.gif");
		imageG32_1 = KImage.getImage("image\\imageG32_1.gif");
		imageG32_2 = KImage.getImage("image\\imageG32_2.gif");
		imageG32_3 = KImage.getImage("image\\imageG32_3.gif");
		imageG33 = KImage.getImage("image\\imageG33.gif");
		imageG34 = KImage.getImage("image\\imageG34.gif");
		imageG35 = KImage.getImage("image\\imageG35.gif");
		imageG36 = KImage.getImage("image\\imageG36.gif");

		KSpriteG31.setImage(KSpriteG31.class, new Image[]{
			imageG31,
			imageG32_0,
			imageG32_1,
			imageG32_2,
			imageG32_3,
			imageG33,
			imageG34,
			imageG35,
			imageG36
		});

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteG31(KPanel panel, double x, int image){

		super(panel);

		int tekiImage = -1;

		// 敵イメージを決定
		tekiImage = (image == G31  )? 0: tekiImage;
		tekiImage = (image == G32_0)? 1: tekiImage;
		tekiImage = (image == G32_1)? 2: tekiImage;
		tekiImage = (image == G32_2)? 3: tekiImage;
		tekiImage = (image == G32_3)? 4: tekiImage;
		tekiImage = (image == G33  )? 5: tekiImage;
		tekiImage = (image == G34  )? 6: tekiImage;
		tekiImage = (image == G35  )? 7: tekiImage;
		tekiImage = (image == G36  )? 8: tekiImage;

		setImage(tekiImage);

		super.setLayoutX(x);
		super.setLayoutY(-128);

	} // end KSpriteG31

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		// スーパークラスを呼び出す
		// 移動はスーパークラスで制御
		super.run();

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 50点
		((KCtrlSKK)panel.getKCtrl()).addScore(50);

		super.bomb();

	} // end bomb

}
