import javafx.scene.image.Image;

/**
 * 地面８１ 恒星 青い星
 * J81 Blue-Planet
 */
public class KSpriteJ81 extends KSprite implements KConstant {

	/** 時間 */
	private		int		time		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageJ81 = null;

		imageJ81 = KImage.getImage("image\\imageJ81.gif");

		KSpriteJ81.setImage(KSpriteJ81.class, imageJ81);

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteJ81(KPanel panel){

		super(panel);

		super.setLayoutX(-300);
		super.setLayoutY(-getHeight());

	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * </pre>
	 */
	public void run(){

		// 時間＋１
		time++;

		// 1/4回
		if(time % 4 == 0){

			// X+1
			super.setLayoutX(super.getLayoutX() + 1);

		}

		// 1/2回
		if(time % 2 == 0){

			// Y+1
			super.setLayoutY(super.getLayoutY() + 1);

			// 画面の外に出た場合、
			if(super.getLayoutY() > HEIGHT){
				// スプライトを消す
				super.removeSprite();
			}

		}

	}

}
