import javafx.scene.image.Image;
import java.util.*;

/**
 * H
 */
public class KSpriteS03 extends KSprite implements KConstant {

	private final int SPRITE_WIDTH = 32;

	private final int MARGIN = 48;

	private final int RANGE = (WIDTH - MARGIN * 2) / 2;

	private final int CENTER = WIDTH / 2 - SPRITE_WIDTH;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageS03 = null;

		imageS03 = KImage.getImage("image\\imageS03.gif");

		KSpriteS03.setImage(KSpriteS03.class, imageS03);

	} // end initImage

	/**
	 * コンストラクタ
	 */
	public KSpriteS03(KPanel panel){

		super(panel);

		super.setLayoutY(-getHeight());

	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 前進
		y = y + 1.0;

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		// X方向はY方向に伴い、円の動き（正弦）を利用する
		x = CENTER + Math.sin(Math.toRadians((y % 360))) * RANGE;

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end run

}
