import javafx.scene.image.Image;

/**
 * 敵１２ レッドロック
 */
public class KSpriteT12 extends KSpriteT00 implements KConstant {

	/** X移動量 */
	private		int				mx				= -1;

	/** 小惑星角度 */
	private		int				angle			= 0;
	private		int				velocity		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT12_00 = null;
		Image imageT12_01 = null;
		Image imageT12_02 = null;
		Image imageT12_03 = null;

		imageT12_00 = KImage.getImage("image\\imageT12_00.gif");
		imageT12_01 = KImage.getImage("image\\imageT12_01.gif");
		imageT12_02 = KImage.getImage("image\\imageT12_02.gif");
		imageT12_03 = KImage.getImage("image\\imageT12_03.gif");

		KSpriteT12.setImage(KSpriteT12.class, new Image[]{
			imageT12_00,
			imageT12_01,
			imageT12_02,
			imageT12_03
		});

	} // end initImage

	/**
	 * コンストラクタ.
	 * @param panel KPanel
	 */
	public KSpriteT12(KPanel panel, String storyParam){

		super(panel);

		// X位置を設定
		super.setLayoutX(Math.random() * (WIDTH - getWidth()));

		super.setLayoutY(-getHeight());

		// X移動量が設定されている場合、
		if(storyParam != null){
			// X移動量を保存
			mx = Integer.parseInt(storyParam);
		}

		// 角度初期化
		angle = (int)(Math.random() * 360);
		velocity = (int)(Math.random() * 30) - 15;

	} // end KSpriteT12

	/**
	 * 実行.
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 親クラスを実行する
		super.run();

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 前進（斜め移動）
		y = y + 8;
		x = x + mx;
 
		// 回転
		angle = angle + velocity;

		// 回転を設定
		super.setRotate(angle);

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end run

	/**
	 * 爆発.
	 */
	public void bomb(){

		// 50点
		((KCtrlSKK)panel.getKCtrl()).addScore(50);

		super.bomb();

	} // end bomb

}
