import javafx.scene.image.Image;

/**
 * 敵１３ クリスタルロック
 */
public class KSpriteT13 extends KSpriteT00 implements KConstant {

	/** 小惑星角度 */
	private		int				angle			= 0;
	private		int				velocity		= 0;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT13 = null;

		imageT13 = KImage.getImage("image\\imageT13.gif");

		KSpriteT13.setImage(KSpriteT13.class, imageT13);

	} // end initImage

	/**
	 * コンストラクタ
	 * @param panel KPanel
	 */
	public KSpriteT13(KPanel panel){

		super(panel);

		// X位置を設定
		super.setLayoutX(Math.random() * (WIDTH - getWidth()));

		super.setLayoutY(-getHeight());

		// 角度初期化
		angle = (int)(Math.random() * 360);
		velocity = (int)(Math.random() * 5);

	} // end KSpriteT13

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 親クラスを実行する
		super.run();

		double y = super.getLayoutY();

		// 前進
		y = y + 3;

		// 回転
		angle = angle + velocity;

		// 回転を設定
		super.setRotate(angle);

		// 画面の外に出た場合、
		if(y > HEIGHT){
			// スプライトを消す
			super.removeSprite();
		}

		super.setLayoutY(y);

	} // end run

	/**
	 * 爆発
	 */
	public void bomb(){

		// 100点
		((KCtrlSKK)panel.getKCtrl()).addScore(100);

		super.bomb();

	} // end bomb

}
