import java.util.List;
import javafx.scene.image.Image;

/**
 * 敵ミサイル
 */
public class KSpriteT9A extends KSprite implements KConstant {

	/** 時間 */
	private		int		time 		= 0;

	/** 移動量 */
	private		int		mY			= 16;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT9A = null;

		imageT9A = KImage.getImage("image\\imageT9A.gif");

		KSpriteT9A.setImage(KSpriteT9A.class, imageT9A);

	} // end initImage

	/**
	 * コンストラクタ
	 * <pre>
	 * ビームです。
	 * </pre>
	 */
	public KSpriteT9A(KPanel panel, KSprite sprite){

		super(panel);

		// 位置を保持
		double x = sprite.getLayoutX() + sprite.getWidth() / 2 - 2;
		double y = sprite.getLayoutY() + sprite.getHeight();

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end KSpriteT9A

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		time++;

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		if(time < 15){
			// 移動
			y = y + 1;

		}else{
			// 移動
			y = y + mY;
		}

		if(y > HEIGHT){
			super.removeSprite();
		}

		super.setLayoutY(y);

		// 自機を取得
		KSpriteShip spriteShip = ((KCtrlSKK)panel.getKCtrl()).getSpriteShip();

		// 位置を取得
		double xSpriteShip = spriteShip.getLayoutX();
		double ySpriteShip = spriteShip.getLayoutY();

		// 当たり判定
		if(xSpriteShip + 4 < (x + super.getWidth()) && x < (xSpriteShip + spriteShip.getWidth() - 4) &&
				ySpriteShip + 4 < (y + super.getHeight()) && y < (ySpriteShip + spriteShip.getHeight() - 4)){

			// 被弾中の場合、
			if(spriteShip.isHidan()){

				// なにもしない

			// 被弾中ではない場合、
			}else{

				// 被弾処理
				spriteShip.hidan();

			} // end if 被弾中ではない場合

		} // end if 当たり判定

	} // end run

}
