import java.util.List;
import javafx.scene.image.Image;

/**
 * 敵ミサイル
 */
public class KSpriteT9B extends KSprite implements KConstant {

	/** 方向 */
	private		String				dir			= null;

	/** 移動量 */
	private		int		mY			= 16;

	/**
	 * イメージ初期化
	 * <pre>
	 * イメージの取り込みを行います。
	 * </pre>
	 */
	public static void initImage() {

		Image imageT9B_UR = null;
		Image imageT9B_UL = null;

		imageT9B_UR = KImage.getImage("image\\imageT9B_UR.gif");
		imageT9B_UL = KImage.getImage("image\\imageT9B_UL.gif");

		KSpriteT9B.setImage(KSpriteT9B.class, new Image[]{imageT9B_UR, imageT9B_UL});

	} // end initImage

	/**
	 * コンストラクタ
	 * <pre>
	 * ビームです。
	 * </pre>
	 * @param panel パネル
	 * @param sprite スプライト
	 * @param dir 方向 UR／UL／DR／DLから指定
	 */
	public KSpriteT9B(KPanel panel, KSprite sprite, String dir){

		super(panel);

		// 方向を保持
		this.dir = dir;

		// 画像の設定
		if("UR".equals(this.dir) || "DL".equals(this.dir)){
			setImage(0);
		}else{
			setImage(1);
		}

		double x = sprite.getLayoutX();
		double y = sprite.getLayoutY();

		if("UR".equals(this.dir)){
			x = x + 40;
			y = y - 40;

		}else if("UL".equals(this.dir)){
			x = x - 40;
			y = y - 40;

		}else if("DR".equals(this.dir)){
			x = x + 40;
			y = y + 40;

		}else if("DL".equals(this.dir)){
			x = x - 40;
			y = y + 40;

		} // end if

		super.setLayoutX(x);
		super.setLayoutY(y);

	} // end KSpriteT9B

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * 継承先で定義をしてください。
	 * <pre>
	 */
	public void run(){

		double x = super.getLayoutX();
		double y = super.getLayoutY();

		// 移動
		if("UR".equals(this.dir)){
			x = x + 20;
			y = y - 20;

		}else if("UL".equals(this.dir)){
			x = x - 20;
			y = y - 20;

		}else if("DR".equals(this.dir)){
			x = x + 20;
			y = y + 20;

		}else if("DL".equals(this.dir)){
			x = x - 20;
			y = y + 20;

		} // end if 移動

		if(y < -30 || y > HEIGHT){
			super.removeSprite();
		}

		super.setLayoutX(x);
		super.setLayoutY(y);

		// 自機を取得
		KSpriteShip spriteShip = ((KCtrlSKK)panel.getKCtrl()).getSpriteShip();

		// 位置を取得
		double xSpriteShip = spriteShip.getLayoutX();
		double ySpriteShip = spriteShip.getLayoutY();

		// 当たり判定
		if(xSpriteShip + 16 < (x + super.getWidth()) && x < (xSpriteShip + spriteShip.getWidth() - 16) &&
				ySpriteShip + 16 < (y + super.getHeight()) && y < (ySpriteShip + spriteShip.getHeight() - 16)){

			// 被弾中の場合、
			if(spriteShip.isHidan()){

				// なにもしない

			// 被弾中ではない場合、
			}else{

				// 被弾処理
				spriteShip.hidan();

			} // end if 被弾中ではない場合

		} // end if 当たり判定

	} // end run

}
